'use strict';

/* Services */
angular.module('app')
    .factory("ProjectService", ['Project', function (Project) {
        var service = {};
        var projects = [];
        service.getProjects = function () {
            return projects;
        };

        service.getProject = function (projectId) {
            var result = null;
            angular.forEach(service.getProjects(), function (project) {
                if (project.projectId === projectId) result = angular.copy(project);
            });
            return result;
        };

        service.updateProject = function (project) {
            angular.forEach(projects, function (p, index) {
                if (p.projectId === project.projectId) {
                    projects[index] = project;
                }
            });
            return project;
        };

        service.addProject = function (project) {
            if (project.projectId) {
                projects.push(project);
                return project;
            }
        }

        service.deleteProject = function (projectId) {
            var projectIndex;
            angular.forEach(projects, function (p, index) {
                if (p.projectId === projectId) {
                    projectIndex = index;
                }
            });
            if (projectIndex >= 0) projects.splice(projectIndex, 1);
        };

        var setupInitialProjects = function () {
            projects.push(
                new Project({
                    projectId:"EC16",
                    project:"EntwicklerCamp",
                    customerId:"RKJ",
                    customer:"RKJ Soft"
                }));

            projects.push(
               new Project({
                    project: "REST Services in Domino - Key to modern Web Applications",
                    projectId: "AD1238",
                    customer: "IBM Connect 2016",
                    customerId: "ibmconnect"
               }));

            

        };

        

        var init = function () {
            setupInitialProjects();
        };

        init();

        return service;
    }]);