'use strict';

/* Services */
angular.module('app')
    .factory("ProjectService", ['Project','$http', function (Project, $http) {
        var service = {};
        var projects = [];
        service.getProjects = function () {
            return projects;
        };

        service.getProject = function (projectId) {
            var result = null;
            angular.forEach(service.getProjects(), function (project) {
                if (project.projectId === projectId) result = angular.copy(project);
            });
            return result;
        };

        service.updateProject = function (project) {
            angular.forEach(projects, function (p, index) {
                if (p.projectId === project.projectId) {
                    projects[index] = project;
                }
            });
            return project;
        };

        service.addProject = function (project) {
            if (project.projectId) {
                projects.push(project);
                $http.post('http://bht9.assono.local/connect2016/ad1238.nsf/customrestservice.xsp/project', project).
            success(function(data, status, headers, config){
                console.log(data);

            }).
            error(function(error, status,headers,config){
                console.log(error);
            })


                return project;
            }
        }

        service.deleteProject = function (projectId) {
            var projectIndex;
            angular.forEach(projects, function (p, index) {
                if (p.projectId === projectId) {
                    projectIndex = index;
                }
            });
            if (projectIndex >= 0) projects.splice(projectIndex, 1);
        };

        var setupInitialProjects = function () {
            $http({method: 'GET', 
                url:'http://bht9.assono.local/connect2016/ad1238.nsf/api/data/collections/name/ProjectsByProjectId'}).
            success(function(data, status, headers, config){
                angular.forEach(data, function (p, index) {
                    console.log(p);
                    projects.push(
                        new Project({
                        projectId:p.Projectid,
                        project:p.Project,
                        customerId:p.CustomerId,
                        customer:p.Customer
                    })); 
                });

            }).
            error(function(error, status,headers,config){
                console.log(error);
            })

        };

        

        var init = function () {
            setupInitialProjects();
        };

        init();

        return service;
    }]);