'use strict';

angular.module('app')
    .factory("ProjectBuilderService", ['ProjectService', 'Project', function (ProjectService, Project) {
        var service = {};
        var buildingProject;
        var newProject;
        service.startBuilding = function (projectId) {
            if (projectId) {
                buildingProject = ProjectService.getProject(projectId);
                newProject = false;
            }
            else {
                buildingProject = new Project({});
                newProject = true;
            }
            return buildingProject;
        };

        service.save = function () {
            var project = newProject ? ProjectService.addProject(buildingProject)
                                : ProjectService.updateProject(buildingProject);
            newProject = false;
            return project;
        };

        service.delete = function () {
            ProjectService.deleteProject(buildingProject.projectId);
        };

        service.canDeleteProject = function () {
            return !newProject;
        }

        return service;
    }]);